GNU bug report logs - #41868
[PATCH] Add project-clean-up command

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: "Philip K." <philip@HIDDEN>; Keywords: patch; dated Mon, 15 Jun 2020 10:02:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 18 Jun 2020 15:36:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 18 11:36:38 2020
Received: from localhost ([127.0.0.1]:54126 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlwak-0004rZ-Bo
	for submit <at> debbugs.gnu.org; Thu, 18 Jun 2020 11:36:38 -0400
Received: from mail-wr1-f47.google.com ([209.85.221.47]:42442)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jlwai-0004rL-IM
 for 41868 <at> debbugs.gnu.org; Thu, 18 Jun 2020 11:36:37 -0400
Received: by mail-wr1-f47.google.com with SMTP id p5so6507098wrw.9
 for <41868 <at> debbugs.gnu.org>; Thu, 18 Jun 2020 08:36:36 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=LiWqJWeEwQgu6dlus1GRL8BDU3vwgBV0N83QI3V1MsI=;
 b=cGMJvr7J0NIn24ik2b0ogdwlhv4zvv6mxq+m8TNCXudm+gby1+wqk4t3kR3fWdhhex
 2767HxAjAB8d44KH+kdYQYQKwfN/EVMK9kuTBCtROIv0CWZuXI7QVPFCqShCmMn7F21E
 MN9sW7GCeQM2XCXFvaOLP/bIcrOpaLu9X1fC9nek4tB6Z230K5noHCsvVdH7hYI7Q8Ym
 jRwem9VHZ0X0tzbwFNsai+4L5BdMfYBtB455KMHTiM3lijJ/Vw/ot7lUcD6H0N5GInCJ
 Wo+RS7GeDMKNh7Xz7GFFJz16vaC5uT8hLEWbF6H1D9MAEBrRDKQz0LnEk41DBB98Uq4r
 KYlw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=LiWqJWeEwQgu6dlus1GRL8BDU3vwgBV0N83QI3V1MsI=;
 b=WYxF8lLZVgctAN9DMEfmN+ihwbrJ8xUGRkyDKgMJj7nMx3+c/gHSPQKz7f7uU9tfNG
 pJxhCeXK02qo2RlMXS9kLtgLogz5o9KtwwQYBL1jQuW1Fm9EwZLRmPv9fLgzUAisuIbv
 8cuq/H8a5KOzuOZomc46wAlhgjnBgyN+FtEa/YxylcewBC4ibcxSe7UzQSQ329q4NgTL
 Vda4N/+CnvI/1X0ofDnpHm9voVIynQtum2sxAS91cwu7oUZMoNgzKp83ejFnkDiQ30Wk
 Vwu+En1Txyi7aYgr8CQAkJFLNKtFP+YRgT9wIlo/rPyUeUFv5ovondJmDbLqXec4FC+C
 gVPw==
X-Gm-Message-State: AOAM533y7++aZYuLTgmmIaZABUYwX6y/FUT3EYipoyqPhwLnKzeo9RgP
 AUBf99NBTWoRDf1bIGMztZntXGU+
X-Google-Smtp-Source: ABdhPJznwEjiyZe/mh7rEdC0UiBgr1mE/z7aKPKTvspYKFc4mSzTf1GMGu03vqBJ24jucfZutSGR9w==
X-Received: by 2002:adf:afdb:: with SMTP id y27mr5027175wrd.267.1592494590411; 
 Thu, 18 Jun 2020 08:36:30 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id a126sm3936137wme.28.2020.06.18.08.36.28
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 18 Jun 2020 08:36:29 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>
References: <87k108wsvb.fsf@HIDDEN> <87d05wea5t.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <6c56f86a-c841-1dd9-3ebf-6c7ae10a150f@HIDDEN>
Date: Thu, 18 Jun 2020 18:36:28 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87d05wea5t.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 18.06.2020 17:11, Philip K. wrote:

>>>> Should we add a key binding for it as well?
>>>
>>> I think 'k' in project-prefix-map would fit well, as soon as that gets
>>> merged.
>>
>> Sounds good.
>>
>> Unless we also wanted a project-scoped version of kill-buffer?
> 
> I'm not sure how interesting that would be.  Buf in that case, I think
> 'k' would be better for that command, and 'K' for kill all the buffers.

Right.

Ok, let's put it on 'k' for now.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 18 Jun 2020 14:11:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 18 10:11:40 2020
Received: from localhost ([127.0.0.1]:53952 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlvGW-0002hY-6j
	for submit <at> debbugs.gnu.org; Thu, 18 Jun 2020 10:11:40 -0400
Received: from wout4-smtp.messagingengine.com ([64.147.123.20]:57211)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jlvGS-0002hJ-DH
 for 41868 <at> debbugs.gnu.org; Thu, 18 Jun 2020 10:11:38 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.west.internal (Postfix) with ESMTP id 7CCC14C7;
 Thu, 18 Jun 2020 10:11:30 -0400 (EDT)
Received: from mailfrontend1 ([10.202.2.162])
 by compute2.internal (MEProxy); Thu, 18 Jun 2020 10:11:30 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:cc:subject:in-reply-to:date:message-id:mime-version
 :content-type; s=fm3; bh=vPE/u8IfVFbhxH3LI46xoA100mnT2oZbTtRRRbm
 CRxM=; b=DcoNm9//EfQArTjD7iisqsD+tLoyya0dPBxKFQ7/BUkL4mSQQ52CUfX
 jMTmlTCuM1mVg7xa3Z+7Cvet39gg0VuaNly1tAnvIxU2ZzVfqoaP5Ose+kP5v4Xz
 6KHV/ce+1XWqjm6QAWwaZQrs2jax7uygCJlWe79POUCHjgUVAl/4dQQGSFy16Kwa
 7rTevAWHh+fGcCfOyYBy4m8qbbKXo+Z8UmkVjFMHSsRLva64NQ+ABHTACHnOQDoL
 LPsLeVeVa4IBvvbE578Osb+XqZGtUkQfGNBLpAmvRHs7TTYxhEtabr6twg6M6ElO
 Qjlvl3v7tFF+VGMXvBPEhbKSThfB9FQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=vPE/u8IfVFbhxH3LI
 46xoA100mnT2oZbTtRRRbmCRxM=; b=RkceE5yrFj36S4dnFGvu9kmSlAnbd983C
 kJ1AYduwr26c74R8MES38pkyKcSJJn2rDUpdA5K2QCgJ/VBM0WrAf2Myg4myR1wj
 neeoNYVozrvLeAhK0hU4V1+lpIB/JuEpUEzX24UkMSZbfDg2WzxvXUnF6Q9zmWDQ
 2lbEk/AbvLiung1PI8ukMKZN8dmylOWT4V9K8Mtr0kGEC9/rLKLc3vR6dmL5L1u4
 XySd/a4tpwOfGluuvHyGmx+wBUyAzLkI9d3Kb2srCvNDE0X++SAGEsKWUro1YD/U
 sgwXqioesO3nskFsUkTrQSrDrhHM7kM0Ra66SUSsqMmxsFq9cEIAQ==
X-ME-Sender: <xms:EXbrXjpCZv6l0bLI3ydS3GjxNySSTfLTXkavFagGcR6reiqr46bKSg>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudejgedgjeegucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfffkgggtsehttdertddttddtnecuhfhrohhmpedfrfhhihhlihhp
 ucfmrddfuceophhhihhlihhpseifrghrphhmrghilhdrnhgvtheqnecuggftrfgrthhtvg
 hrnhepheeuieffveevkeetffeufeekfeejkeekkeefjeelueeftdduffdugfeuieegfffh
 necukfhppeejledrvdduledrudelledrvdduheenucevlhhushhtvghrufhiiigvpedtne
 curfgrrhgrmhepmhgrihhlfhhrohhmpehphhhilhhiphesfigrrhhpmhgrihhlrdhnvght
X-ME-Proxy: <xmx:EXbrXtpqeNLwHJefq-eiGPFFVd3l1jmzf6jK5XHXIekpxHoqPWSh2g>
 <xmx:EXbrXgOznVGUVPtTOe7bUNgs12NFByC8jef-rgpkiDJBoq5rQ2ffRw>
 <xmx:EXbrXm5WoVRTR82YwWovkjhvibk0yJHbLvNpw99TS75hklZhgw2uxQ>
 <xmx:EnbrXvVeKTMB38gjrw1chVWpKp60XMcPgbsQUwk8i63rUxAZ5D3niQ>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id D8FDC3280065;
 Thu, 18 Jun 2020 10:11:28 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <f7c65a94-e43c-4a60-2ef7-b29170a202c0@HIDDEN> (message from
 Dmitry Gutov on Thu, 18 Jun 2020 16:04:17 +0300)
Date: Thu, 18 Jun 2020 16:11:26 +0200
Message-ID: <87d05wea5t.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 18.06.2020 09:46, Philip K. wrote:
>
>>> Thank you, I pushed with some minor changes.
>>>
>>> - Docstring further rephrased based on Basil's suggestion.
>>> - The variable renamed to project-kill-buffers-skip-conditions, hope you
>>> don't mind.
>> 
>> I don't mind, I just thought that I had sent a patch fixing that
>> already?
>
> If you did, I couldn't find it. Sorry.

My mistake, it seems like I never sent the mail :/ But since it was
mostly the same, it's irrelevant.

>>> Should we add a key binding for it as well?
>> 
>> I think 'k' in project-prefix-map would fit well, as soon as that gets
>> merged.
>
> Sounds good.
>
> Unless we also wanted a project-scoped version of kill-buffer?

I'm not sure how interesting that would be.  Buf in that case, I think
'k' would be better for that command, and 'K' for kill all the buffers.

-- 
	Philip K.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 18 Jun 2020 13:04:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 18 09:04:27 2020
Received: from localhost ([127.0.0.1]:53067 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jluDS-0000na-WB
	for submit <at> debbugs.gnu.org; Thu, 18 Jun 2020 09:04:27 -0400
Received: from mail-wr1-f48.google.com ([209.85.221.48]:46463)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jluDR-0000nM-0q
 for 41868 <at> debbugs.gnu.org; Thu, 18 Jun 2020 09:04:25 -0400
Received: by mail-wr1-f48.google.com with SMTP id x6so5952661wrm.13
 for <41868 <at> debbugs.gnu.org>; Thu, 18 Jun 2020 06:04:24 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=seH3z+b+G6z/OZzD9rGh7YAWuorBGO3JSvobqKVucq0=;
 b=ijxp9PScjLnbExFyvv0bviqaL96eollNvdW6T9lMGZtHMNIRndU76WL3Owe2BhqVp9
 +fJlXTJC2yEEuMcgBTtpJ3PBnCuaHUQj040WINPvSb5aSI/n+78arnUtqyAHnQv1b3L0
 OSnpIc42o3kF0X+z7c8LIUj1hERoeAXmdKwj0TnmrDRcb2h3lB6IQpxAGrKvO6urDwr8
 /1nZXz4DYPEnOLXz2VQFCCjB6DW0w0gFKmyR9tW/RsaZDkR+i402pweTWfLHTlJpNo1q
 N/xgwGWU7Mc8W3L5nxf+TKYcY1jYeUEh470SET8sW1BfOxiRtoVbcOie1aqfKdkDLKFK
 0NeQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=seH3z+b+G6z/OZzD9rGh7YAWuorBGO3JSvobqKVucq0=;
 b=M40QSidLrDjrRrJgXzw7ToEnxC++RmLS+fkitYnDhKqo2SxN7+qpoQsoXB9P2Dr2e6
 2jARsZMnTQzt9RK0MDNIzw6S2JTlovfOyMNF6VRg2VyG5teTePdw6N/Ddl5VsKfGj4dj
 kGHox4t8ZJMtj60v25J5kZc7MrlMVvZdF9wbW+Grsr4fbX0WkXxWs0AmicQLOtXOGEZ5
 26Q2c4BrpFXLzJVt92cva6KWj3211VoQqvfP0xMA81ZinXJ/tio48LNyH63FwCCgSvdA
 k+lORyNOkQeW42ahaW4ZeX37yqAesVjlIoZQHSVfovIHBa35m68lDswY1p56LYQn1fu6
 k2TQ==
X-Gm-Message-State: AOAM5331xyuQ/w5VzY8yegXUVJc7EncGNhtajMXWtFmX9Rvzutewfrmw
 B6m8t8famYaSuevGcwwwz7YOp65X
X-Google-Smtp-Source: ABdhPJwEyuNP6LHXq75Hm3FeW4gT2720P0SJsgj132qQMgqV83ksZA+P03eH8ewc0YrjulS4ymFYKg==
X-Received: by 2002:adf:c6c5:: with SMTP id c5mr4318288wrh.13.1592485459064;
 Thu, 18 Jun 2020 06:04:19 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id r7sm3247632wmh.46.2020.06.18.06.04.17
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Thu, 18 Jun 2020 06:04:18 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>
References: <87k108wsvb.fsf@HIDDEN> <87r1uceur9.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <f7c65a94-e43c-4a60-2ef7-b29170a202c0@HIDDEN>
Date: Thu, 18 Jun 2020 16:04:17 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87r1uceur9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 18.06.2020 09:46, Philip K. wrote:

>> Thank you, I pushed with some minor changes.
>>
>> - Docstring further rephrased based on Basil's suggestion.
>> - The variable renamed to project-kill-buffers-skip-conditions, hope you
>> don't mind.
> 
> I don't mind, I just thought that I had sent a patch fixing that
> already?

If you did, I couldn't find it. Sorry.

>> Should we add a key binding for it as well?
> 
> I think 'k' in project-prefix-map would fit well, as soon as that gets
> merged.

Sounds good.

Unless we also wanted a project-scoped version of kill-buffer?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 18 Jun 2020 06:46:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 18 02:46:48 2020
Received: from localhost ([127.0.0.1]:52645 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jloK0-00042k-C8
	for submit <at> debbugs.gnu.org; Thu, 18 Jun 2020 02:46:48 -0400
Received: from out1-smtp.messagingengine.com ([66.111.4.25]:41925)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jloJv-00042S-Gi
 for 41868 <at> debbugs.gnu.org; Thu, 18 Jun 2020 02:46:47 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.nyi.internal (Postfix) with ESMTP id 613FA5C012A;
 Thu, 18 Jun 2020 02:46:38 -0400 (EDT)
Received: from mailfrontend2 ([10.202.2.163])
 by compute2.internal (MEProxy); Thu, 18 Jun 2020 02:46:38 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:cc:subject:in-reply-to:date:message-id:mime-version
 :content-type; s=fm3; bh=lhMMk6yRKISYRC1Cla5oazN5jgXDRTEolebLukw
 UfkQ=; b=O13HEBl2Qat8gpmlQMh13ZOx8T2uPvF7Eg1AFVq31gpu9OioGQZiZJW
 eg2deMG9UZoJPgqPW+FvRaCSxCgHouzkn/CUi7gNQl2IP8TwmAPt5vbQEQsDV48C
 n+Q7SlJmT2tT2LgPBpiJGFycRvk/s8Ad5IIK9o9mKyFzOybcywpQ0zABkH6ertST
 f0Ipf5I6F9dMKcgMumqx/R7mUrYeDTjDdbWblIcVth1WDMAHN6GNr0LsvBZrurZl
 aHnG/qiMGiXSSBhFCoxgGV5zzYtUMqOjIYs+uIicSZHzfpcdo6YdtqE4z4zWCZ25
 WFK5bGmoDY+x2zusdlzRSjtjnNqTrBA==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=lhMMk6yRKISYRC1Cl
 a5oazN5jgXDRTEolebLukwUfkQ=; b=XKtEy9hY1UjlQsaS6K3A7sgNFm6Fc4sOA
 aFcPXTBCtI51gYLo7v39VZb3lCdUgWWyppBXtd1yQWZF+cv1KjGgy3gV180W2i3Y
 8BhrYmHiyC3Gica4j7wFwkqj47P4frbXF0CAp/eTa8zcLrBgH4l9z2GIylJXrC2W
 f6vOXAGWpzgWXfHh/HPKfxKCkoL3nWL5zZjDGABa78gaPFs08xQ0re2mKxB68OF4
 VNEuK58b3F3okZoL3iNcGiQCSDdxFRXenwQX/zNs6cUd9M7DXg9AIj3+0EcYkjbG
 9WdISdbZe0xwYlVereRzJ+HRpwPS/9tCCDAk6D7PLsHDYI2rdnraA==
X-ME-Sender: <xms:zQ3rXvRIn5QKOlhgIUjDIi-TIiCVPdLq6vZzcjmIEsbAD-l-T1UETQ>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudejfedguddugecutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmd
 enucfjughrpefhvffujgffkfggtgesthdtredttddttdenucfhrhhomhepfdfrhhhilhhi
 phcumfdrfdcuoehphhhilhhiphesfigrrhhpmhgrihhlrdhnvghtqeenucggtffrrghtth
 gvrhhnpeehueeiffevveekteffueefkeefjeekkeekfeejleeufedtudffudfgueeigeff
 hfenucfkphepjeelrddvudelrdduleelrddvudehnecuvehluhhsthgvrhfuihiivgeptd
 enucfrrghrrghmpehmrghilhhfrhhomhepphhhihhlihhpseifrghrphhmrghilhdrnhgv
 th
X-ME-Proxy: <xmx:zQ3rXgxkQ4SZ4gWg2z32lMYfgM8GMmIvRD7Fz15Ay6DAKWqpVO-_Lw>
 <xmx:zQ3rXk25BHfn4v1laY3Ygo2amh6bOS1IFGOJ8urGGoS4ujMZTzBlMg>
 <xmx:zQ3rXvB_XckLzxT4Iphtfof57coDc-AsVyKTu6WVuoBCx8SW97pAQQ>
 <xmx:zg3rXgLTIAqZyTXrScZpRWJkJXm_1ulqlFWYc1db7TpX_0T4CME0Bw>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id 9CB7F30618B7;
 Thu, 18 Jun 2020 02:46:37 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <9d3788f2-d482-7f84-0d90-951692da969c@HIDDEN> (message from
 Dmitry Gutov on Thu, 18 Jun 2020 04:05:55 +0300)
Date: Thu, 18 Jun 2020 08:46:34 +0200
Message-ID: <87r1uceur9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, eliz@HIDDEN, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 16.06.2020 20:12, Philip K. wrote:
>> It sounds good, so I used it in the revised patch below, together with a
>> few other minor improvments which Basil mentioned.
>
> Thank you, I pushed with some minor changes.
>
> - Docstring further rephrased based on Basil's suggestion.
> - The variable renamed to project-kill-buffers-skip-conditions, hope you 
> don't mind.

I don't mind, I just thought that I had sent a patch fixing that
already?

> Should we add a key binding for it as well?

I think 'k' in project-prefix-map would fit well, as soon as that gets
merged.

-- 
	Philip K.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 18 Jun 2020 01:06:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 17 21:06:09 2020
Received: from localhost ([127.0.0.1]:52469 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlj0K-00048z-Qb
	for submit <at> debbugs.gnu.org; Wed, 17 Jun 2020 21:06:08 -0400
Received: from mail-wm1-f43.google.com ([209.85.128.43]:36778)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jlj0F-00048N-O1
 for 41868 <at> debbugs.gnu.org; Wed, 17 Jun 2020 21:06:07 -0400
Received: by mail-wm1-f43.google.com with SMTP id d128so3885681wmc.1
 for <41868 <at> debbugs.gnu.org>; Wed, 17 Jun 2020 18:06:03 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=BMke7jPyTBsh6CeI7v1+scO+FNtoZwILYeS1z1eOJyI=;
 b=nvKYu4rF7QhF4/aoOPuD5qPCeuGR5KyTPwPcmn+GKX4gvlwz2+I0SEAtNPTapcStJ7
 45y7sHxii+wafP8zg0AzpnK8X5E2VPZcuk1oee+pHRNTZ6Ul7sOYH22hP+mkH2eG3/Xd
 5IBtUMelAZL70f4p1WzV3h+O0wOT2rcQRfGNu+pymYSeRJ3D+15xhybRcgEO4HqYmWjv
 Wy2MadubCLY710LfLKlToCa2lWPdxQplS2GujYtNO6W5qYDGWl27ZaaCjEXn0WHmFwan
 6bxkdUzojg+7CWiaabzwk//kryUttf7/6k35R2/7C4hGQYW9UXzOwp1tHhkMla88LjsR
 wjVQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=BMke7jPyTBsh6CeI7v1+scO+FNtoZwILYeS1z1eOJyI=;
 b=huPxUEh5v40H89IEKEWKcMPoTOHRQP2OEJyFH+4cnLpqhe7f1WjXBYbw0QFTm6WOOj
 oaQwxkHiJpNgxtPESq5GBW9Z6kaxE9MjE2TKStASnukZARx1f9/Cpe83AcvMdcaSjYnB
 vgI9/ebj5YkEmHQEmc0IantB9p6BtKjCd2CdmGTYPU4sD9EGdQXQtgEbMTsRRUeMSXgW
 iv0lCPWT+1fvBqaRqhLvW39VaFj4VnZvfyN6erAPBPnThDsYYezZ0UaT6xu6VxgVzm1M
 bzFCCwcdgRhcZHWZALZlcuw9+MCgs7qq1y1lzvrfam5nJ0wlQtwBxVGxY028wzUjXX26
 ZgEQ==
X-Gm-Message-State: AOAM533HnN2YIIBnYKUDIpDFtwN4LMT13Jm+PMm4AismkepgYM25pZob
 jYLC8Tri2XFtta0KG4nmdZo8a0lV
X-Google-Smtp-Source: ABdhPJykM0WS22yTWBw/220YtKCojF3edC3djp7acMh/aOgrvfQq4YmXWkgh04BaF9ZS06MzO0A6iQ==
X-Received: by 2002:a1c:2082:: with SMTP id g124mr1375973wmg.21.1592442357659; 
 Wed, 17 Jun 2020 18:05:57 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id y25sm9157522wmi.2.2020.06.17.18.05.56
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Wed, 17 Jun 2020 18:05:57 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <877dw7q6ij.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <9d3788f2-d482-7f84-0d90-951692da969c@HIDDEN>
Date: Thu, 18 Jun 2020 04:05:55 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <877dw7q6ij.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 16.06.2020 20:12, Philip K. wrote:
> It sounds good, so I used it in the revised patch below, together with a
> few other minor improvments which Basil mentioned.

Thank you, I pushed with some minor changes.

- Docstring further rephrased based on Basil's suggestion.
- The variable renamed to project-kill-buffers-skip-conditions, hope you 
don't mind.

Should we add a key binding for it as well?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 22:00:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 18:00:19 2020
Received: from localhost ([127.0.0.1]:49802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlJcx-0004zM-0H
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 18:00:19 -0400
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:53711)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1jlJcv-0004z6-4D
 for 41868 <at> debbugs.gnu.org; Tue, 16 Jun 2020 18:00:18 -0400
X-Originating-IP: 91.129.108.6
Received: from mail.gandi.net (m91-129-108-6.cust.tele2.ee [91.129.108.6])
 (Authenticated sender: juri@HIDDEN)
 by relay4-d.mail.gandi.net (Postfix) with ESMTPSA id 328ADE0003;
 Tue, 16 Jun 2020 22:00:08 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
Organization: LINKOV.NET
References: <87pna0qjkf.fsf@HIDDEN>
 <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN>
 <87d060dktc.fsf@HIDDEN>
 <c14bc9d2-ee51-b1ba-515f-743ca7bf3ff6@HIDDEN>
Date: Wed, 17 Jun 2020 00:47:46 +0300
In-Reply-To: <c14bc9d2-ee51-b1ba-515f-743ca7bf3ff6@HIDDEN> (Dmitry Gutov's
 message of "Tue, 16 Jun 2020 03:23:00 +0300")
Message-ID: <874kraitv1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: "Philip K." <philip@HIDDEN>, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> I think the suffix ‘-regexps’ is fine.  The problem is that
>> the word “spare” has no reference to the related command name
>> ‘project-kill-buffers’.  Maybe better would be something like
>> ‘project-kill-buffers-ignore-regexps’ or
>
> "kill or spare", no? But it's not immediately obvious for non-native
> speakers, sure.
>
>> For functions it's easy to add a separate variable like
>> ‘project-kill-buffers-ignore-functions’.
>
> I don't see why we wouldn't want to keep it on the same variable. It's both
> easier to document, and to implement.

Then just ‘project-kill-buffers-ignore’ should be fine: short and clear.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 17:12:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 13:12:51 2020
Received: from localhost ([127.0.0.1]:49522 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlF8h-0006Kn-2X
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 13:12:50 -0400
Received: from wout5-smtp.messagingengine.com ([64.147.123.21]:37021)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jlF8f-0006Kc-R9
 for 41868 <at> debbugs.gnu.org; Tue, 16 Jun 2020 13:12:46 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.west.internal (Postfix) with ESMTP id 083D139A;
 Tue, 16 Jun 2020 13:12:39 -0400 (EDT)
Received: from mailfrontend1 ([10.202.2.162])
 by compute2.internal (MEProxy); Tue, 16 Jun 2020 13:12:40 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:cc:subject:in-reply-to:date:message-id:mime-version
 :content-type; s=fm3; bh=KahKOLXX7PvYqT42QQJs8Vj8H6dWZPVspDzTe0V
 NyKE=; b=S4rBlGG/P+F02KXizE5oCbEh28Akft0GxYH4axICkOgklrhoxIey3a3
 3O7JbsxdhkWVPYqiXIqRMcMFmv5aOhwUIsReS8zw6q0nQL7BgfKsq//VvnBWhYuY
 6HDGvuQ3R0bUjf11JoVySpUbXQmcxK04+1vMB9BafCyYhV1vfJs0YPZnTIEEdP1j
 qaDp3NrP+zUZXuqE02QMdZb0d1yc20vVXI9AQAO7ULo+FnkzsNJEMxT0YVVmKA4D
 DrnglLR09PeqSUV/V03UU1RN2eY3YtCmfHVIle8rUBKvaV+IKwjJToIx+KZAATcY
 jG0KcIJqCdH8rapmOt+xh+eJxrTMkHQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=KahKOLXX7PvYqT42Q
 QJs8Vj8H6dWZPVspDzTe0VNyKE=; b=EuXxyx5q2O9iuRwi+P01uckZMALbUIphy
 6D+Pvg26X9n7ApIXoXOKzwTXlxKE/IrNFT99I5r/A6BeoHVvVzL8tQMrkaKOhvyL
 3xIXq0hHf7r7ZvoHAku+6nCps/ZR8UUesyc9/6Z4bw5HeR90hWvwciIdPb+L54nE
 HU/Vp+vrHW83FimEJsbSadvRxnlRa5wAbUe9B+6egXpMECIj998QJ/KPmwScaHxN
 DsQxeSmyH3P5tk+9P6tQOEb2Imjo12sqYTEozOHNn0QeqiljPGpEJJythiSC+GUL
 /2MIQVqlKUkIVYp80Uj4iyD2mh7+t+SmKa+DhlSoz0xPIVPO55VMw==
X-ME-Sender: <xms:h_3oXgv_bdFeNTDbUR-qkbT6wRXqXSWh-l2p3TNwXf-2lpLaJzSY4w>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudejtddguddugecutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmd
 enucfjughrpefhvffujgffkfggtgesmhdtreertddttdenucfhrhhomhepfdfrhhhilhhi
 phcumfdrfdcuoehphhhilhhiphesfigrrhhpmhgrihhlrdhnvghtqeenucggtffrrghtth
 gvrhhnpeejieeuvdellefffefgueetkeelkeegveffieeffffhgfeuueehvdelvdeuvefh
 geenucfkphepjeelrddvudelrdduleelrddvudehnecuvehluhhsthgvrhfuihiivgeptd
 enucfrrghrrghmpehmrghilhhfrhhomhepphhhihhlihhpseifrghrphhmrghilhdrnhgv
 th
X-ME-Proxy: <xmx:h_3oXteVE-_D-QPYhCbpAcjeWB5HA5gJ6bkZwLl6Z9801ZK7_-gizQ>
 <xmx:h_3oXrxOiu9mU0N4o1iy_gWOunWiKiLpujhLErDyF6STKnuyXzcLHw>
 <xmx:h_3oXjPa0yKfv9bJ80rEQ-Y_7o4fF5ZvAMp0WgFEI2oNd9E493Q-uA>
 <xmx:h_3oXlEHNBV1Y4UkaBohtRYVuIbZThjAnjM7jEt-cbe7HCLWtZxTTw>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id C0EE4328005D;
 Tue, 16 Jun 2020 13:12:38 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <83o8pj13rq.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 16
 Jun 2020 17:31:05 +0300)
Date: Tue, 16 Jun 2020 19:12:36 +0200
Message-ID: <877dw7q6ij.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: contovob@HIDDEN, 41868 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: "Basil L. Contovounesios" <contovob@HIDDEN>
>> Date: Tue, 16 Jun 2020 11:52:26 +0100
>> Cc: 41868 <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
>> 
>> Perhaps some of the common wording can be factored out as well
>> (feel free to adapt as you see fit):
>> 
>>     "List of conditions to be ignored by `project-kill-buffers'.
>
> The first line is too general, and could deceive.  How about
>
>   Conditions for buffers `project-kill-buffers' should not kill.

It sounds good, so I used it in the revised patch below, together with a
few other minor improvments which Basil mentioned.

-- 
	Philip K.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Add-project-kill-buffers-command.patch

From 2172f4d3d310d75dadf5ef0af297476e873349b8 Mon Sep 17 00:00:00 2001
From: Philip K <philip@HIDDEN>
Date: Fri, 12 Jun 2020 23:37:51 +0200
Subject: [PATCH] Add project-kill-buffers command

---
 lisp/progmodes/project.el | 42 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 42 insertions(+)

diff --git a/lisp/progmodes/project.el b/lisp/progmodes/project.el
index f3df44fa7b..04d3b324d6 100644
--- a/lisp/progmodes/project.el
+++ b/lisp/progmodes/project.el
@@ -744,6 +744,48 @@ project-compile
          (default-directory (project-root pr)))
     (compile command comint)))
 
+(defcustom project-spare-buffers-conditions
+  '("\\*Help\\*")
+  "Conditions for buffers `project-kill-buffers' should not kill.
+If a condition is a string, it will be interpreted as a regular
+expression, and matched against the buffer name.  If a condition
+is a function, it will be called with the buffer object, and
+returns non-nil if it matches.  Buffers that match any condition
+are \"spared\", and will hence not be killed by
+`project-kill-buffers'."
+  :type '(repeat (choice regexp function))
+  :version "28.1")
+
+(defun project--buffer-list (pr)
+  "Return a list of all buffers in project PR."
+  (let ((root (project-root pr)) bufs)
+    (dolist (buf (buffer-list))
+      (let ((filename (or (buffer-file-name buf)
+                          (buffer-local-value 'default-directory buf))))
+        (when (and filename (file-in-directory-p filename root))
+          (push buf bufs))))
+    (nreverse bufs)))
+
+;;;###autoload
+(defun project-kill-buffers ()
+  "Kill all live buffers of a project.
+Certain buffers may be ignored, depending on the value of
+`project-spare-buffers-conditions'."
+  (interactive)
+  (let ((pr (project-current t)) bufs)
+    (dolist (buf (project--buffer-list pr))
+      (unless (seq-some
+               (lambda (c)
+                 (cond ((stringp c)
+                        (string-match-p c (buffer-name buf)))
+                       ((functionp c)
+                        (funcall c buf))))
+               project-spare-buffers-conditions)
+        (push buf bufs)))
+    (when (yes-or-no-p (format "Kill %d buffers in %s? "
+                               (length bufs) (project-root pr)))
+      (mapc #'kill-buffer bufs))))
+
 
 ;;; Project list
 
-- 
2.20.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 14:31:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 10:31:33 2020
Received: from localhost ([127.0.0.1]:49360 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jlCce-0002Jz-Qv
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 10:31:33 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46786)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1jlCcd-0002Jn-9u
 for 41868 <at> debbugs.gnu.org; Tue, 16 Jun 2020 10:31:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57408)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1jlCcX-0000jp-8i; Tue, 16 Jun 2020 10:31:25 -0400
Received: from [176.228.60.248] (port=4199 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1jlCcU-0007Wi-JN; Tue, 16 Jun 2020 10:31:24 -0400
Date: Tue, 16 Jun 2020 17:31:05 +0300
Message-Id: <83o8pj13rq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
In-Reply-To: <878sgni8ph.fsf@HIDDEN> (contovob@HIDDEN)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
References: <87k108wsvb.fsf@HIDDEN> <87ftawq9qy.fsf@HIDDEN>
 <878sgni8ph.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 41868
Cc: philip@HIDDEN, 41868 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: "Basil L. Contovounesios" <contovob@HIDDEN>
> Date: Tue, 16 Jun 2020 11:52:26 +0100
> Cc: 41868 <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
> 
> Perhaps some of the common wording can be factored out as well
> (feel free to adapt as you see fit):
> 
>     "List of conditions to be ignored by `project-kill-buffers'.

The first line is too general, and could deceive.  How about

  Conditions for buffers `project-kill-buffers' should not kill.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 10:52:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 06:52:37 2020
Received: from localhost ([127.0.0.1]:48362 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jl9Cn-0003AR-6n
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 06:52:37 -0400
Received: from mail-wm1-f41.google.com ([209.85.128.41]:56263)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1jl9Cl-0003AD-3I
 for 41868 <at> debbugs.gnu.org; Tue, 16 Jun 2020 06:52:35 -0400
Received: by mail-wm1-f41.google.com with SMTP id c71so2404121wmd.5
 for <41868 <at> debbugs.gnu.org>; Tue, 16 Jun 2020 03:52:34 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=f/tYgOvTnvtffMVYLsWGBWeEZUg7X7oAacQvcDGTOY0=;
 b=uklT3KK8IZXu8y7XGtqaollBdkd9aniRLTLl6uFMGzpDuxFGbejc8NtigNbZScXNBT
 te56sV9g8w7RsxqZM33n3DIFetL9d5UKYVfX/6VoOt6ZTd5/7287ATFsSG75PFcby6SI
 3wIKORLkvf/6C7KOhOOGix53CM9KWcK8c8Pspm8zVGb/t9FDxl00FnUORuO+aUK2UbfZ
 CMCiCjbmtqz3g4u714VBdASwrlxg09oBn4qkCLAP9B279unJQhlGvroqFMhJve2MYuuT
 0iCRXh3dQVjqLVLrxC4CX6O9lqJEnwUApyrgtr29Z1VoKS7picgShXl/YJ85L6bIdMJq
 DpbA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=f/tYgOvTnvtffMVYLsWGBWeEZUg7X7oAacQvcDGTOY0=;
 b=K/N374/xNra2LjRwONYAXGlUzC9X08KjZDGbUt8U4zXrs0SFko86Xe5Leujcd8ipyX
 aRIl8bZxKrv9YGZO4MpB89K5zvyWGVjdrDCQuv4eijXRAxygCK0uFU4G/bz1akgsRd9m
 Z1YZzd1QmGjuVcgbJG9HYZfmONXL5FbA4Nivfb6Y/rcMEYAO338CTmopZ+8rTLeOvFs5
 TYbCiHxrvLdgZUK2SE0MwLuQ0h7ZanrbiIvTuh5zhMFJZaM5CjNyCJ5RemMV0C19RnJM
 7DKjegB7stQo5s0PcUbKcul6iyi1sdbNbYWBDUuXZlMut3LOMthSnVw9esr9/RQ8099W
 rr1A==
X-Gm-Message-State: AOAM531m4zFzj3xZc1vksoKQ8qFAmAP5U4i1BmdIlt0m/NqcZpHdwLH6
 zKloe6WCrsz3fLb2qtTrIIO0Bg==
X-Google-Smtp-Source: ABdhPJyaP72QMAsmZPM5xe55EEXkEztWRQQ5IIgvC+nDJpw8Ofb7In/prWa0Oy2uNcnfOxKe+MtgOg==
X-Received: by 2002:a1c:9ec5:: with SMTP id h188mr2558543wme.9.1592304749217; 
 Tue, 16 Jun 2020 03:52:29 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:1f68:7ff5:120d:64e])
 by smtp.gmail.com with ESMTPSA id m24sm3422002wmi.14.2020.06.16.03.52.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 16 Jun 2020 03:52:28 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: "Philip K." <philip@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
References: <87k108wsvb.fsf@HIDDEN> <87ftawq9qy.fsf@HIDDEN>
Date: Tue, 16 Jun 2020 11:52:26 +0100
In-Reply-To: <87ftawq9qy.fsf@HIDDEN> (Philip K.'s message of "Mon, 15
 Jun 2020 23:50:29 +0200")
Message-ID: <878sgni8ph.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org, Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

"Philip K." <philip@HIDDEN> writes:

> (naively) Hoping everything it ok this time.

Just one tiny detail from me. ;)

> +(defcustom project-spare-buffers-conditions
> +  '("\\*Help\\*")
> +  "List of conditions to be ignored by `project-kill-buffers'.
> +If a condition is a string, it will be interpreted as a regular
> +expression. If the buffer name matches the regular expresion, the
> +buffer will not be killed.  If a contition is a function, it will
> +be called with the buffer object. If it returns a non-nil value,
> +the buffer will not be killed."

Some of the full stops aren't followed by two spaces here
(see sentence-end-double-space in Emacs' dir-locals-file).

Perhaps some of the common wording can be factored out as well
(feel free to adapt as you see fit):

    "List of conditions to be ignored by `project-kill-buffers'.
  Buffers under the current project that match any of these
  conditions will not be killed by `project-kill-buffers'.  Each
  condition is either a regular expression matching a buffer name,
  or a predicate function that takes a buffer object as argument
  and returns non-nil if it matches."

> +  (let* ((pr (project-current t)) bufs)

Nit: No need for let*.

Thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 10:19:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 06:19:13 2020
Received: from localhost ([127.0.0.1]:48348 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jl8gT-0002Hm-7K
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 06:19:13 -0400
Received: from mail-wm1-f49.google.com ([209.85.128.49]:35235)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jl8gR-0002HX-J9
 for 41868 <at> debbugs.gnu.org; Tue, 16 Jun 2020 06:19:12 -0400
Received: by mail-wm1-f49.google.com with SMTP id q25so2497861wmj.0
 for <41868 <at> debbugs.gnu.org>; Tue, 16 Jun 2020 03:19:11 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=CJ4QKYVbeD0T56xpNRxXW7B4BrWPPdo/a7rRgpTRcvM=;
 b=V/29gkeY7p3l6NgveIuTh0EyxPUheUN+AVRDEhvuso9MxO9xjFk8Xj7KaQ3PY6xF7K
 8TRK9JU3ka5/fSQfcTYfB16igawzMp7qGH61t3Fy+dT9QNOzzP0UvDzx6ub6xtUnPWt8
 LaPNZT5/K4eR9k0NOI5V9Nk7Z7xa5lvF+XcFMWd9/4JITyWMNXEhIbTYCd5heREkG9CG
 WLQvDya8mC+jFXhuIUD4bhlKBGeW7aVDiZI8REyPg/oc9dGzDCohXn+UcsUxhm1s38fg
 +TsmQEryETMskJIl6iqoOsiV72ZQcFPGLVDnBH0yCktiCgCctvNjBF7NMic0n7e6x3sG
 Qs4w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=CJ4QKYVbeD0T56xpNRxXW7B4BrWPPdo/a7rRgpTRcvM=;
 b=arrpqmwHgGJ6NIepe/BCLOlTHtQhQfro9MvM8kemkHSCWNb0x/bB1funjXZghjjkLX
 6rAgU2pMkF3Q2pAfMaM4lsW8soXLRWpFc3WpLzNYbbIRVOCYVwZyRem20x+GtgmCdO5v
 5TmeCUCGcesehdl9nikaMcp/PF1dYZBduU5hXLVdg72XQKlTlOamlY5S7tcmch17G8Xs
 LfB5BbHeDjUc7yGzi652gtnEeKStzcwHwAPuGciq8uZYGn63+l/snGRYk/aNtfuxrBf8
 j+uCyl7R7CTKQ3kLeAJT1eS12wqVQbfjKqtyc1FJR6lhzZqEalsk7FNJriMYYAYtQY8w
 LdOQ==
X-Gm-Message-State: AOAM530jvY1hb98vXFmxnN5Vb6vjiQjvcc8BHzFoCByLBOMGtT3fj7pG
 m3lAZ/OhCDZ4wslXHUW9IAFjrGAW
X-Google-Smtp-Source: ABdhPJxQpAMws9cI2+GoPp7jNfTlsiuWInclPTH7h7Sucypa7cbOGrJjCNZNyzHvOBiCeT5779y83A==
X-Received: by 2002:a1c:658a:: with SMTP id z132mr2422069wmb.20.1592302745555; 
 Tue, 16 Jun 2020 03:19:05 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id k64sm3398379wmf.34.2020.06.16.03.19.04
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Tue, 16 Jun 2020 03:19:04 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>
References: <87k108wsvb.fsf@HIDDEN> <87ftawq9qy.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <a9d84c82-9fbe-184e-2151-fb9c756518ae@HIDDEN>
Date: Tue, 16 Jun 2020 13:19:03 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87ftawq9qy.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 16.06.2020 00:50, Philip K. wrote:
> (naively) Hoping everything it ok this time.

Thanks! It's looking good.

Let's also hear what Juri thinks. To address one of his concerns, the 
var could be renamed to project-kill-buffers-spare-conditions.

One added benefit of this is it would be immediately clear from the name 
that it only affects a specific command.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Jun 2020 06:39:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 16 02:39:30 2020
Received: from localhost ([127.0.0.1]:48096 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jl5Fp-0005Rg-PL
	for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 02:39:30 -0400
Received: from lists.gnu.org ([209.51.188.17]:39308)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jl5Fo-0005RY-6B
 for submit <at> debbugs.gnu.org; Tue, 16 Jun 2020 02:39:28 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:40654)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <philip@HIDDEN>)
 id 1jl5Fm-0008WD-SB
 for bug-gnu-emacs@HIDDEN; Tue, 16 Jun 2020 02:39:27 -0400
Received: from wout2-smtp.messagingengine.com ([64.147.123.25]:44013)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <philip@HIDDEN>)
 id 1jl5Fk-0004Yl-OJ
 for bug-gnu-emacs@HIDDEN; Tue, 16 Jun 2020 02:39:26 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.west.internal (Postfix) with ESMTP id E4EC835F
 for <bug-gnu-emacs@HIDDEN>; Tue, 16 Jun 2020 02:39:22 -0400 (EDT)
Received: from mailfrontend2 ([10.202.2.163])
 by compute2.internal (MEProxy); Tue, 16 Jun 2020 02:39:23 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 resent-from:resent-date:resent-to:from:to:cc:subject:in-reply-to
 :date:message-id:mime-version:content-type:resent-message-id; s=
 fm3; bh=obGbQJiqYylNLJZiVB21LbD0D+aBdIdazBC7DI1eyes=; b=mz0AN56m
 QdFcuDPcFpj72q5WrkMHddXLGR1yMilzFHmEmayTjKgW9dgMDWlV9+1PCX8+g9Kb
 jeaATSmrNLMFjHFhLScKAb+SSKmi2NcKuEtZNQlBN664KEZNJaLh+ci3Cq73bfFT
 i4j0WUc8EQWMTVtu4gAjbN2Z+mvc+kocbAOBsFMW85IwIE8jjTGwGnJuc+rvciwO
 yNwPdrpf237acu51RJs6afr9IjXELS8+HHLCJAJd4qNZWRxBfuCGM8vcqp6jGoqr
 1CY1WRd5IuRw1+4A38m4FtTT3RKx4YAAXn4mdsBX1YJf2uN9eVmRb8r/c305a2/u
 4iWViA+8brAmFw==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:resent-date:resent-from
 :resent-message-id:resent-to:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=obGbQJiqYylNLJZiV
 B21LbD0D+aBdIdazBC7DI1eyes=; b=KV/e3nQ3Me/uStDvs+yDSv6LkJ+nhoh3d
 EOykLIwjCootJxKhKBbutOpzUU8eX8wvKE7JrVNlLkckh7n3Ha2jywm10owqsdMr
 7NLQdAA00oXv1y5fI1C0DC9IIYh1j85qVLIxtOSCu7Qsxpm2CVZcW6DpSm4Lg+rT
 0T4sVz6tArHNQ234ALKayvMUkD0j1lerkv0bU/mf9A6/WcfHrQPyYsa+eUisYiFu
 DJvJhS4+F9vgSKiamT8ncQKIPQck5U3UdF2r5GxhkKF7nRjDVib7PFB/Fzy4L4Mi
 xphm+GESqtWEXt0o2+ll+o79oznJALELMmmcVJiC8XTOiarwa4DEQ==
X-ME-Sender: <xms:GmnoXpz5KDx8WyTd1r4Xos7qEm7mwwgmETmOAP6uko1KvLmHx2X8-w>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudeiledgudduvdcutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmd
 enucfjughrpefhvffujgffkfggtgesmhdtreertddttdenucfhrhhomhepfdfrhhhilhhi
 phcumfdrfdcuoehphhhilhhiphesfigrrhhpmhgrihhlrdhnvghtqeenucggtffrrghtth
 gvrhhnpeejieeuvdellefffefgueetkeelkeegveffieeffffhgfeuueehvdelvdeuvefh
 geenucfkphepjeelrddvudelrdduleelrddvudehnecuvehluhhsthgvrhfuihiivgeptd
 enucfrrghrrghmpehmrghilhhfrhhomhepphhhihhlihhpseifrghrphhmrghilhdrnhgv
 th
X-ME-Proxy: <xmx:GmnoXpSLehkDK6SMcGqDWBmwo8UmTx0HkX1swUlLDyqfSK2bRBcDIQ>
 <xmx:GmnoXjW-ZO4Hlm9fAraQ4-FepHctH8sC8v3Uqj06i3M9wOA1tMOx8Q>
 <xmx:GmnoXrgGiJeeMtAR5_umeXhZEO2wc9JaZZhCMnhi8tQhSxwRTdPPBA>
 <xmx:GmnoXvxkU0VQhzthr-wO49iC89SbDjGQ9ttL3YSU2KZIw8oSCLyPvA>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id D90CF3061856
 for <bug-gnu-emacs@HIDDEN>; Tue, 16 Jun 2020 02:39:21 -0400 (EDT)
Resent-From: philip@HIDDEN
Resent-Date: 16 Jun 2020 08:39:19 +0200
Resent-To: bug-gnu-emacs@HIDDEN
From: "Philip K." <philip@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN> (message from
 Dmitry Gutov on Mon, 15 Jun 2020 23:50:51 +0300)
X-Draft-From: ("gmane.emacs.bugs" 181991)
Date: Mon, 15 Jun 2020 23:50:29 +0200
Message-ID: <87ftawq9qy.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-RMAIL-ATTRIBUTES: --------
Resent-Message-Id: <20200616063921.D90CF3061856@HIDDEN>
Received-SPF: pass client-ip=64.147.123.25; envelope-from=philip@HIDDEN;
 helo=wout2-smtp.messagingengine.com
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/06/16 02:39:23
X-ACL-Warn: Detected OS   = Linux 2.2.x-3.x [generic] [fuzzy]
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H3=-0.01, RCVD_IN_MSPIKE_WL=-0.01,
 SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 URIBL_BLOCKED=0.001 autolearn=_AUTOLEARN
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

--=-=-=
Content-Type: text/plain

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 15.06.2020 21:18, Philip K. wrote:
>
>  > +(defcustom project-spare-buffers-regexps
>  > +  '("\\*Help\\*")
>
> Perhaps also call this project-buffer-spare-conditions? Or something 
> like that. Point is, no tie the name to regexps, for easy extension into 
> having functions in that list as well.

Renamed it an implemented support for predicates too.

>  > +  "List of regular expressions to be ignored by `project-clean-up'."
>
> Forgotten reference to the previous name.

There was also some superfluous code from an attempt to reimplement
yes-or-no-p with a third option I removed. Also fixed an inconsistency,
where the prompt would tell the user that more buffers would be killed
that would actually be, depending on the value of
project-buffer-spare-conditions.

(naively) Hoping everything it ok this time.

-- 
	Philip K.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Add-project-kill-buffers-command.patch

>From 20ab9f1f8fe603e8ea8fe24a7d0e1fdd60be08bb Mon Sep 17 00:00:00 2001
From: Philip K <philip@HIDDEN>
Date: Fri, 12 Jun 2020 23:37:51 +0200
Subject: [PATCH] Add project-kill-buffers command

---
 lisp/progmodes/project.el | 41 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 41 insertions(+)

diff --git a/lisp/progmodes/project.el b/lisp/progmodes/project.el
index f3df44fa7b..50155e55dd 100644
--- a/lisp/progmodes/project.el
+++ b/lisp/progmodes/project.el
@@ -744,6 +744,47 @@ project-compile
          (default-directory (project-root pr)))
     (compile command comint)))
 
+(defcustom project-spare-buffers-conditions
+  '("\\*Help\\*")
+  "List of conditions to be ignored by `project-kill-buffers'.
+If a condition is a string, it will be interpreted as a regular
+expression. If the buffer name matches the regular expresion, the
+buffer will not be killed.  If a contition is a function, it will
+be called with the buffer object. If it returns a non-nil value,
+the buffer will not be killed."
+  :type '(repeat (choice regexp function))
+  :version "28.1")
+
+(defun project--buffer-list (pr)
+  "Return a list of all buffers in project PR."
+  (let ((root (project-root pr)) bufs)
+    (dolist (buf (buffer-list))
+      (let ((filename (or (buffer-file-name buf)
+                          (buffer-local-value 'default-directory buf))))
+        (when (and filename (file-in-directory-p filename root))
+          (push buf bufs))))
+    (nreverse bufs)))
+
+;;;###autoload
+(defun project-kill-buffers ()
+  "Kill all live buffers of a project.
+Certain buffers may be ignored, depending on the value of
+`project-spare-buffers-conditions'."
+  (interactive)
+  (let* ((pr (project-current t)) bufs)
+    (dolist (buf (project--buffer-list pr))
+      (unless (seq-some
+               (lambda (c)
+                 (cond ((stringp c)
+                        (string-match-p c (buffer-name buf)))
+                       ((functionp c)
+                        (funcall c buf))))
+               project-spare-buffers-conditions)
+        (push buf bufs)))
+    (when (yes-or-no-p (format "Kill %d buffers in %s? "
+                               (length bufs) (project-root pr)))
+      (mapc #'kill-buffer bufs))))
+
 
 ;;; Project list
 
-- 
2.20.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 00:23:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 20:23:09 2020
Received: from localhost ([127.0.0.1]:47714 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jkzNc-00028U-QH
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 20:23:09 -0400
Received: from mail-wr1-f52.google.com ([209.85.221.52]:33659)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jkzNb-00028F-MO
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 20:23:08 -0400
Received: by mail-wr1-f52.google.com with SMTP id l11so18930247wru.0
 for <41868 <at> debbugs.gnu.org>; Mon, 15 Jun 2020 17:23:07 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=lwWUXw5VtQkHzOCDcGkvVVAgQKWY8/SPVjfimjdjHa0=;
 b=NyO02T/peTbBiOrQBGzPiz3pF4uLim3Uqobxg3jgH40NYTfpUKcZTeplfDNH51dQgE
 B2TFCKSLcW78Y2kHOisxmdwL25bPgT+I9Q4FkwMiuxQDUQSkRuFa2ZsHWb4KovcEQVQD
 ytII1hRYNjU4vDSoQWC4lN50Ve/f1Cj1kpMu8m65wcC9DVJQg2QSvBo58BZSz/puDrVm
 /Kc9o7ReRJIBgxsk7R7TgtbzcAzKWae0TUpWulfFbRY9fh9sWjdvvunZASEdprc34GeI
 6GSHdKmZhn+AAOLf8IXUjuFbvzeofB/twPd66mZ+rZGO3YdQQRoTakQoPCjVh5IArqcl
 Ieyg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=lwWUXw5VtQkHzOCDcGkvVVAgQKWY8/SPVjfimjdjHa0=;
 b=llCQDRRk0RuXgpJiEFuCbNb23xp/Xp1lS4yYZjP6pq4/wXZ0Ib3p2Cl3eE0F+wobVz
 5lXVMAQKtuqH0lsxGxxM0zgL2jR/tkNK9nc7857a1GnpD2HMsTjigO0ak+ycLo83vVUP
 GA84gstR8ntJsXUKWsMKXoOxOAViewHyOFNYZaAMUHhHPN4nMsQTMKR26+fmhq5uud5R
 eiDjQsWIm44JYcSrSYdOGfymK48ZQKKXMcM6pG1LhW0G/bYADuF8eor+A0BU+QglTOLW
 RZcdCP4ISi/4Qp5hMp0jd/I4TyxJldEBRv7fS7C61PA9JRWsFO1kMzR60dKA5mQ4QBiv
 stmg==
X-Gm-Message-State: AOAM532A4dS+5CGC0a9m/drJfVGrU1HB+u0xVEoUaaK+6EAD1HGDNIy+
 dBFIqblXQmJIeA8WGp4oNyNXo4FH
X-Google-Smtp-Source: ABdhPJxSeQGrBepeFuwf9KLUOHGACGC/JihoJerzp6MWPNK+NySU11Vekj11y7VQzIVTEpyBJ200wQ==
X-Received: by 2002:adf:fec9:: with SMTP id q9mr162712wrs.172.1592266981837;
 Mon, 15 Jun 2020 17:23:01 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id u7sm27166060wrm.23.2020.06.15.17.23.00
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 15 Jun 2020 17:23:01 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: Juri Linkov <juri@HIDDEN>
References: <87pna0qjkf.fsf@HIDDEN>
 <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN>
 <87d060dktc.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <c14bc9d2-ee51-b1ba-515f-743ca7bf3ff6@HIDDEN>
Date: Tue, 16 Jun 2020 03:23:00 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87d060dktc.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: "Philip K." <philip@HIDDEN>, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 16.06.2020 01:49, Juri Linkov wrote:
>>> +(defcustom project-spare-buffers-regexps
>>> +  '("\\*Help\\*")
>>
>> Perhaps also call this project-buffer-spare-conditions?
> 
> I think the suffix ‘-regexps’ is fine.  The problem is that
> the word “spare” has no reference to the related command name
> ‘project-kill-buffers’.  Maybe better would be something like
> ‘project-kill-buffers-ignore-regexps’ or

"kill or spare", no? But it's not immediately obvious for non-native 
speakers, sure.

>> Or something like that. Point is, no tie the name to regexps, for easy
>> extension into having functions in that list as well.
> 
> For functions it's easy to add a separate variable like
> ‘project-kill-buffers-ignore-functions’.

I don't see why we wouldn't want to keep it on the same variable. It's 
both easier to document, and to implement.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 16 Jun 2020 00:02:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 20:02:53 2020
Received: from localhost ([127.0.0.1]:47682 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jkz41-0007wS-HI
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 20:02:53 -0400
Received: from relay7-d.mail.gandi.net ([217.70.183.200]:45397)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1jkz3z-0007wD-1S
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 20:02:52 -0400
X-Originating-IP: 91.129.108.6
Received: from mail.gandi.net (m91-129-108-6.cust.tele2.ee [91.129.108.6])
 (Authenticated sender: juri@HIDDEN)
 by relay7-d.mail.gandi.net (Postfix) with ESMTPSA id 2459020006;
 Tue, 16 Jun 2020 00:02:42 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
Organization: LINKOV.NET
References: <87pna0qjkf.fsf@HIDDEN>
 <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN>
Date: Tue, 16 Jun 2020 01:49:51 +0300
In-Reply-To: <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN> (Dmitry Gutov's
 message of "Mon, 15 Jun 2020 23:50:51 +0300")
Message-ID: <87d060dktc.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: "Philip K." <philip@HIDDEN>, 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> +(defcustom project-spare-buffers-regexps
>> +  '("\\*Help\\*")
>
> Perhaps also call this project-buffer-spare-conditions?

I think the suffix ‘-regexps’ is fine.  The problem is that
the word “spare” has no reference to the related command name
‘project-kill-buffers’.  Maybe better would be something like
‘project-kill-buffers-ignore-regexps’ or

> Or something like that. Point is, no tie the name to regexps, for easy
> extension into having functions in that list as well.

For functions it's easy to add a separate variable like
‘project-kill-buffers-ignore-functions’.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 20:51:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 16:51:02 2020
Received: from localhost ([127.0.0.1]:47584 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jkw4M-0001Ai-J4
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 16:51:02 -0400
Received: from mail-wr1-f66.google.com ([209.85.221.66]:41239)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jkw4J-0001AE-RH
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 16:51:01 -0400
Received: by mail-wr1-f66.google.com with SMTP id j10so18527829wrw.8
 for <41868 <at> debbugs.gnu.org>; Mon, 15 Jun 2020 13:50:59 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=S50LRYbeVVdqx67RMkj2juEp1iJ88Cp+qKwLBRFOan8=;
 b=QbhrqNmSnUhSxJ7OeC+VEIxxH+jIM18C0xZzfJBvJr77xoHT3C4cVxNrZpdF6/wYMB
 3HT1MTiHkJ3L1m9WpZLJ5Tc2GRZpFNJb5h4szJQtZtUyvujMaVcZZYZKczucwsaR+YKE
 mOxP7Hf36AsK0WkINNEJAaXqgXoTuuXn7U6Dgoc8gWJf2OoZoy9jUP5OERL8P6ZhnvCz
 ueCXUFqskzk1whyg+fij+9r0rDPbykuvVBApdxx58upOgKH0dDgNbGuDWpl7fIzbLJWW
 X5TSY7UYuA1QE2ozlaf30Yh1Bj9aEFKWLThAEKCbbFQzpUE+VQIY/dLWeM8Q76BDDUAL
 X5BQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=S50LRYbeVVdqx67RMkj2juEp1iJ88Cp+qKwLBRFOan8=;
 b=a0++j0MN+axBxMd3lZdORKLnb/E6rYiC4WjzYCBD5KYywu2k95bEdOH65KLwb8z4sm
 SvIAOl13GrEJXsoV0d1siU+kOhpdVMV2EUDpfdS/E5tB+dDtRr/JhyUAaHRHZVPXLkvV
 NK1laOHdI7t/TUhQ7xvwaIQFu7fRVmg8kNDQdGAruJKp/yNJLGTkccXvYYGhSNmhv8h+
 PIsrwKBQelbxxkeJd1lzuA9MegaTzlsZA9zHnoJmTqjGGEWizDy9wCZc5+keJyLacdyy
 iMGJ7QmbW1UZgsAKiEF7tnGlk2yJbl1502OCROlRE2oY3fcu4HMc6vQ8wAA9CCVaU4qa
 sfew==
X-Gm-Message-State: AOAM532fbmioFirqGu95CJy42YBHfizvyMceHYxOP4ONJpFLBzIVIyXJ
 4ogosUsAEqvlCYwzj2vZYi9kVSJX
X-Google-Smtp-Source: ABdhPJwdEI0xqJSTgpGissbicWlRDDHWuH9pJMUSznkxNjKRrvKmYr61+GCZ1lf3IVAzWvG4946xSw==
X-Received: by 2002:adf:aa42:: with SMTP id q2mr32507579wrd.360.1592254253401; 
 Mon, 15 Jun 2020 13:50:53 -0700 (PDT)
Received: from [192.168.0.3] ([66.205.73.129])
 by smtp.googlemail.com with ESMTPSA id f11sm25515302wrj.2.2020.06.15.13.50.52
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 15 Jun 2020 13:50:52 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>
References: <87pna0qjkf.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <3937d6bc-1fbb-6389-1d54-e5c254343324@HIDDEN>
Date: Mon, 15 Jun 2020 23:50:51 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87pna0qjkf.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 15.06.2020 21:18, Philip K. wrote:
> I changed the name to project-kill-buffer in the patch below. It kind of
> feels like a ripoff now, but there probably aren't that many way to
> implement the idea either.

Indeed. And, well, following the example in a few (functional) names 
shouldn't be considered a fault WRT copyright.

Taking pains to be "different" won't serve anyone either.

 > +(defcustom project-spare-buffers-regexps
 > +  '("\\*Help\\*")

Perhaps also call this project-buffer-spare-conditions? Or something 
like that. Point is, no tie the name to regexps, for easy extension into 
having functions in that list as well.

 > +  "List of regular expressions to be ignored by `project-clean-up'."

Forgotten reference to the previous name.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 18:18:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 14:18:35 2020
Received: from localhost ([127.0.0.1]:47474 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jktgp-0003mr-7O
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 14:18:35 -0400
Received: from out3-smtp.messagingengine.com ([66.111.4.27]:44599)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jktgm-0003mc-IE
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 14:18:33 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.nyi.internal (Postfix) with ESMTP id 3DC195C014B;
 Mon, 15 Jun 2020 14:18:27 -0400 (EDT)
Received: from mailfrontend1 ([10.202.2.162])
 by compute2.internal (MEProxy); Mon, 15 Jun 2020 14:18:27 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:cc:subject:in-reply-to:date:message-id:mime-version
 :content-type; s=fm3; bh=zWMVt1/jV/dZDyWiZ9anyXiMb2oJ0KRAyTKahIm
 c7+M=; b=UnkHBPNifF4xc6i1kFjNrGCoaHgB3xXP5vxF5c1YMvW7KiAEIF/zPJB
 s8J6XerAmynCrWAScz3YIq1fwmibqLk/d1Daa85Kkl5wYkSZRBAdx4ga6mB9J+8n
 IGvL+H1Q2TsqIG7mt22IlH5rX1lB21ylBClOzY8EFhALegdlnMvL5ERWed4ah/xr
 PV/154lejjEg8PSO/k6Ps7HWtlKLLSfFnEEsv8CIO5jshKSjVzVOLQZ63Xovw4xb
 IkL+E+XLXnSQHadShH2aM2Fm2oCNMx5NZZbyYBw8rWw/aS807EDlIz/1X5pN4tju
 YofVUjsxMVyql45JF8XzGDLXlN1Pp0g==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=zWMVt1/jV/dZDyWiZ
 9anyXiMb2oJ0KRAyTKahImc7+M=; b=tqvOsoYyxzEMuDkcsqxqmo8blEIZ1spTg
 s9ER6EtpZC2EnBiXNjPrnMQNzsarVSWQxN18fVEYXSCGeU9ETwmQAxre5ijhPEUH
 D4LlYuXcLgLOvtRVpd+ECAzy+w5ZcsoXoh4TGppF0wmMxui09NpdZeqt+mYhL5h3
 rbcRuO4ujvsgZe/dvmZhWgXRXflLXUJKNz6BGumLBnVwuHzPpg899qPv0n6HXatI
 88UaQqdhuIVAzCgkeB6LAqXOY9HmgFFFhMfGGGp5U2qetDLMuydeicsaIuqKpGh1
 4B/iX81JGVphikA+wr6zVHU1YGEvDbvrEhGwk38WkS1hApeQs0SvQ==
X-ME-Sender: <xms:crvnXmMzG_UH6IOEmqVccxAD0DhiMA1UlULfcY8khXdeEwQwPrh3KA>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudeikedguddvgecutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmd
 enucfjughrpefhvffujgffkfggtgesmhdtreertddttdenucfhrhhomhepfdfrhhhilhhi
 phcumfdrfdcuoehphhhilhhiphesfigrrhhpmhgrihhlrdhnvghtqeenucggtffrrghtth
 gvrhhnpeevuddvheeugefgteetheeukeeiledvgfdtffetueetgeffhfektedujeefheej
 tdenucffohhmrghinhepghhithhhuhgsrdgtohhmnecukfhppeejledrvdduledrudelle
 drvdduheenucevlhhushhtvghrufhiiigvpedtnecurfgrrhgrmhepmhgrihhlfhhrohhm
 pehphhhilhhiphesfigrrhhpmhgrihhlrdhnvght
X-ME-Proxy: <xmx:crvnXk_v-U3Apxl5gzRPnwnDx5Mmhbdrmx51EnBmDGUgEpqtkqz5Qg>
 <xmx:crvnXtQ2oNaJlG6z9Scf21DtzcOICi_biPj9z03gALVP6oXPkyYtxw>
 <xmx:crvnXms8zfv6uE8_THrxBPM8X1MHFcQea2Y3L5SsUHzhefZo19p42g>
 <xmx:c7vnXoqHC_Qt3sgTwdyD0ztvuAJdbtQaS0xw6cBfJSKg7cw1Obn_pA>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id 9EFD4328005D;
 Mon, 15 Jun 2020 14:18:26 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <74f8cf68-211f-8dea-532c-842bd4a70cc1@HIDDEN> (message from
 Dmitry Gutov on Mon, 15 Jun 2020 15:28:20 +0300)
Date: Mon, 15 Jun 2020 20:18:24 +0200
Message-ID: <87pna0qjkf.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Dmitry Gutov <dgutov@HIDDEN> writes:

> On 15.06.2020 13:00, Philip K. wrote:
>> I wanted to propose a command for project.el to kill all opened buffers
>> in a project, called when one finishes working on some specific
>> code-base. I gave it the name "project-clean-up", but maybe it should be
>> renamed?
>
> I've just looked it up, and Projectile has a command called 
> project-kill-buffers. Perhaps follow its example?
>
> https://github.com/bbatsov/projectile/blob/33bc91e7518fb8cecd89580f16e0ac21799de2c2/projectile.el#L3642
>
> I somewhat prefer the explicit naming. Looking at it, you won't mistake 
> it for a command that removes build artefacts, or "tidies up" the code, 
> for instance.

I changed the name to project-kill-buffer in the patch below. It kind of
feels like a ripoff now, but there probably aren't that many way to
implement the idea either.

Hope I didn't miss any of the issues brought up.

-- 
	Philip K.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Add-project-kill-buffers-command.patch

From 35c10566382dd31442fd59bf8e3ee695dc595386 Mon Sep 17 00:00:00 2001
From: Philip K <philip@HIDDEN>
Date: Fri, 12 Jun 2020 23:37:51 +0200
Subject: [PATCH] Add project-kill-buffers command

---
 lisp/progmodes/project.el | 33 +++++++++++++++++++++++++++++++++
 1 file changed, 33 insertions(+)

diff --git a/lisp/progmodes/project.el b/lisp/progmodes/project.el
index f3df44fa7b..6fe5dfa880 100644
--- a/lisp/progmodes/project.el
+++ b/lisp/progmodes/project.el
@@ -744,6 +744,39 @@ project-compile
          (default-directory (project-root pr)))
     (compile command comint)))
 
+(defcustom project-spare-buffers-regexps
+  '("\\*Help\\*")
+  "List of regular expressions to be ignored by `project-clean-up'."
+  :type '(repeat regexp)
+  :version "28.1")
+
+(defun project--buffer-list (pr)
+  "Return a list of all buffers in project PR."
+  (let ((root (project-root pr))
+        bufs)
+    (dolist (buf (buffer-list))
+      (let ((filename (or (buffer-file-name buf)
+                          (buffer-local-value 'default-directory buf))))
+        (when (and filename (file-in-directory-p filename root))
+          (push buf bufs))))
+    (nreverse bufs)))
+
+;;;###autoload
+(defun project-kill-buffers ()
+  "Kill all live buffers of a project."
+  (interactive)
+  (let* ((pr (project-current t))
+         (bufs (project--buffer-list pr)))
+    (with-temp-buffer
+      (setf (buffer-name) " *project buffer list*")
+      (when (yes-or-no-p (format "Kill %d buffers in %s? "
+                                 (length bufs) (project-root pr)))
+        (dolist (buf bufs)
+          (unless (seq-some (lambda (re)
+                              (string-match-p re (buffer-name buf)))
+                            project-spare-buffers-regexps)
+            (kill-buffer buf)))))))
+
 
 ;;; Project list
 
-- 
2.20.1


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 12:28:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 08:28:31 2020
Received: from localhost ([127.0.0.1]:45418 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jkoE2-0000oZ-St
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 08:28:31 -0400
Received: from mail-wr1-f45.google.com ([209.85.221.45]:43993)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1jkoE1-0000oM-9v
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 08:28:29 -0400
Received: by mail-wr1-f45.google.com with SMTP id l10so16900539wrr.10
 for <41868 <at> debbugs.gnu.org>; Mon, 15 Jun 2020 05:28:29 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=cp76ThY+NiIr0FxfjVONSQ0CTGaPIOAyqPWPWtDyWu4=;
 b=pQNd1MOilRE7W/q3TnI2W/AEkRncNuoHIbq9uqyzZLQnmEB451LTtU0L7dj6wXj3GI
 8NSLX2awvkng5sSOJ4H0FJWcEsTejy224rPdKo9GiaRTEKgduKns+0wfkiu+JI2OkhFz
 xYI/xaCLBLOzvAhzIEQKqOBk3Zb5zxxL+M0KmJj/FLwCrpyK7Tk4hB9InDT3A6xpNyVG
 Pifd9LRZJgUJNWOOX9a3tuE5a9fadYyAeoQD4HnTy6fRmrfqHn7JsbhjHIowPw4g33ws
 B4jx/qW2PcOGsfDbJIHthPW9MHWnv/ITeFskCgGy+JlJa00kwGTRoidpLzvG3tgkGtVJ
 Rw/w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=cp76ThY+NiIr0FxfjVONSQ0CTGaPIOAyqPWPWtDyWu4=;
 b=TN2As5C8cBZ6hYCcb3ExTvIzk2umSA3r2wvFa+PwJl1EpnLYMPW8ieVbUp8kX5rEVX
 0Hsrs2YPNaj86zjP2Xp8chacwnADXncmhZonXIYv6GPxkMBgGQUCdNBO6ZT6V8KWU5Zn
 cnOL3EEKKXSyl3/8s/rYASfLhIQDpSY0k3CJNjoYr+DRJD+TZ6YfjbQiLWN2/wD02Mx/
 S8y9wN82LBdAFTtGU4hk2FRhCez7fsOLNeKdViA2TnKEhZ+zbgXYlmC66B4CrhAzFn3w
 Fhvi6roQ1u1P0VYzon8nnnoHAmL+/Zfips5Ysusut7vrfLzDqAvnXB9ftP6bCgMZHrOd
 V/eA==
X-Gm-Message-State: AOAM533ylwhFxFNCVSKy4UvnTeNqx5gU+SKVi/MhHCBatpu2Y1RlMQ9+
 AgLP0rhlFbW4hR7T8EA7bLGu8Ywq
X-Google-Smtp-Source: ABdhPJwoevdX3OYiunoQjdKiRqZB0gKGIie/8nfJZiXRt6c2SRIhp5t4JSrLzjujwVmLiIUbDnVC9g==
X-Received: by 2002:a5d:5270:: with SMTP id l16mr28781827wrc.80.1592224103090; 
 Mon, 15 Jun 2020 05:28:23 -0700 (PDT)
Received: from [192.168.0.117] ([109.110.245.170])
 by smtp.googlemail.com with ESMTPSA id n19sm21780033wmi.33.2020.06.15.05.28.21
 (version=TLS1_3 cipher=TLS_AES_128_GCM_SHA256 bits=128/128);
 Mon, 15 Jun 2020 05:28:22 -0700 (PDT)
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
To: "Philip K." <philip@HIDDEN>, 41868 <at> debbugs.gnu.org
References: <87k108wsvb.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <74f8cf68-211f-8dea-532c-842bd4a70cc1@HIDDEN>
Date: Mon, 15 Jun 2020 15:28:20 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.8.0
MIME-Version: 1.0
In-Reply-To: <87k108wsvb.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 41868
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 15.06.2020 13:00, Philip K. wrote:
> I wanted to propose a command for project.el to kill all opened buffers
> in a project, called when one finishes working on some specific
> code-base. I gave it the name "project-clean-up", but maybe it should be
> renamed?

I've just looked it up, and Projectile has a command called 
project-kill-buffers. Perhaps follow its example?

https://github.com/bbatsov/projectile/blob/33bc91e7518fb8cecd89580f16e0ac21799de2c2/projectile.el#L3642

I somewhat prefer the explicit naming. Looking at it, you won't mistake 
it for a command that removes build artefacts, or "tidies up" the code, 
for instance.

> I have been using it in my local emacs branch for about a week,
> and have found it to be useful.

Sounds useful indeed!




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 11:38:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 07:38:48 2020
Received: from localhost ([127.0.0.1]:45356 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jknRw-0007k2-Fj
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:38:48 -0400
Received: from mail-wr1-f45.google.com ([209.85.221.45]:44383)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1jknRt-0007jn-PK
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:38:46 -0400
Received: by mail-wr1-f45.google.com with SMTP id y17so16725708wrn.11
 for <41868 <at> debbugs.gnu.org>; Mon, 15 Jun 2020 04:38:45 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=d59zS9gOGHUoDW40QOWFM6i1GNM1THPs5gb8gM51TCs=;
 b=yk/KBRNaAqSsNu0C7VXEM5Fg5AaJ9NRUMG07VMhj/vNTI4Vm8DLZKEYnOBQwtzbO7Z
 tRcEmdJHY35Ezh/XD4K4peN4Jwa2Y6T+0K2PTlBkDgNCrT/VRg9xD0Jm7zizAndRtwE8
 qGrU1cF0CFnp0h99tm4SSkJpTHkdp/FCPwed1nZukZ3BKIxqcMWuWA3Fn7UIY6t3W9Uw
 Ioh/Va2AM9R4zGfNurlTcEh8Bo37YIC0eLo53MFmmgklG2r1KQzU8a11CacuiXg1zPzx
 5Y66TWok20Zd6sHP0TEsxKHJVx1oWEQRTzrBR+LlALI8oSGxma4nhIK4L9bAQWPJ2xIF
 b/iw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=d59zS9gOGHUoDW40QOWFM6i1GNM1THPs5gb8gM51TCs=;
 b=QQc7GifG2SeQsNmW96goGwDYuKAsuQqeEdB0f7btkvDliHpptNi+ug83MBoOzSTGLw
 AZITjJsD0Jc7hH6Yqf0ztw2jHpLTAct5Xp8hTL47+yo6XLR149FTtoJEc9qiqy/ZsTOq
 gYftHMnqAxYam/ydZMFN2ghQ78LNfBnR8lsJD70VKcah68ApwKXwBkmHSQ+vWoDoE7ce
 berAUQwuvWAaQHbN360Jxln25jSWPgekaFPr4y5nUMl0CKn34hBakbEhWZFSeSWzJ7aC
 TJyeFfv42CF+EZVtC8lWdsQwGFgqJdC27npGs2Tz9e2rwqRlP1J8wjD5eNXwYLXi37Kf
 OEWA==
X-Gm-Message-State: AOAM532B3ASCKroTXS9KJlu5A7lUZwtJBbeQ946MMTudthOLHC9WlgkX
 G14CdOOd9qBPTkRlXUxn5U6uFg==
X-Google-Smtp-Source: ABdhPJyzi+bW8EJnng2KPNS1Oz0+KVCi/1yv+xeJ1O80jyMF3TMz/BRmLz1d7i8xc/gSRAIBz9gFoQ==
X-Received: by 2002:a05:6000:10c3:: with SMTP id
 b3mr30168089wrx.53.1592221119945; 
 Mon, 15 Jun 2020 04:38:39 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:1f68:7ff5:120d:64e])
 by smtp.gmail.com with ESMTPSA id p9sm21641903wma.48.2020.06.15.04.38.38
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Jun 2020 04:38:39 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: "Philip K." <philip@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
References: <87wo48r2cr.fsf@HIDDEN>
Date: Mon, 15 Jun 2020 12:38:38 +0100
In-Reply-To: <87wo48r2cr.fsf@HIDDEN> (Philip K.'s message of "Mon, 15
 Jun 2020 13:32:36 +0200")
Message-ID: <87imfspni9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

"Philip K." <philip@HIDDEN> writes:

> Thanks for the notes, just a few questions/justifications below:
>
> "Basil L. Contovounesios" <contovob@HIDDEN> writes:
>
>>> +        (when (file-in-directory-p true root)
>>> +          (push buf bufs))))
>>> +    bufs))
>>
>> Maybe the list should be returned in the same order as (buffer-list), by
>> using either nreverse or seq-filter?
>
> Is there any benifit to this, or is this just a matter of not disrupting
> expectations? My thought was that this was more like a set than a proper
> list (despite the function name).

I just thought it might be more natural to process buffers in their
usual order, in case it makes a difference in any kill-buffer-related
hooks.  It probably doesn't matter much.

>>> +    (dolist (buf (project--list-buffers pr))
>>> +      (let ((match (mapcar (lambda (re)
>>> +                             (and (string-match-p re (buffer-name buf)) t))
>>> +                           project-dont-clean-regexps)))
>>> +        (unless (memq t match)
>>> +          (kill-buffer buf))))))
>>
>> Nit: AKA
>>
>>   (unless (seq-some (lambda (re)
>>                       (string-match-p re (buffer-name buf)))
>>                     project-dont-clean-regexps)
>>     ...)
>
> Would this require adding a "(require 'seq)" to the top? I always kind
> of hesistate in adding new dependencies in patches, but if it's already
> loaded, it would look better this way.

A lot of seq.el functions are autoloaded, including seq-some.

Thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 11:32:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 07:32:48 2020
Received: from localhost ([127.0.0.1]:45351 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jknM7-0007bE-Qc
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:32:48 -0400
Received: from out5-smtp.messagingengine.com ([66.111.4.29]:48523)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jknM5-0007b0-4a
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:32:46 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.nyi.internal (Postfix) with ESMTP id E9CBA5C0106;
 Mon, 15 Jun 2020 07:32:39 -0400 (EDT)
Received: from mailfrontend1 ([10.202.2.162])
 by compute2.internal (MEProxy); Mon, 15 Jun 2020 07:32:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:cc:subject:in-reply-to:date:message-id:mime-version
 :content-type; s=fm3; bh=13EzZWme3ZcL3ch+K5q+GuXZepVH5OdxynoOLIR
 1/xE=; b=LnESMGkSM3ICqqR22bmah+RGGN3l8sRHed9DePIpGmWuTp49jWBgbuJ
 Ovx9ZOORiHXWX4JAlFb7SyUMA5NXIdocA2ZJquVizh0PW1vM6U5/mjz1KbIugjh5
 Q0EolgHLMEYfJLBuqNqvz2AJlDSoNqC8g+nggVIRQvY8HJw094meUxzCJhS58QP+
 hPpqTlK8q2mrB6G8rURc+WazxyIUl3/6B6c4ADnDlBvz0UqO0Yq3Suhw2KpQL5sS
 yKNZZLs3C/MJh/rDlgqM42VWFQ/QkmhBOu8KolUej0Oo4VkxA9p4JHdc5nbdcUG9
 89B+WMxUxRDWltXbJCCJHiB6BSEXtAQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:subject:to:x-me-proxy:x-me-proxy
 :x-me-sender:x-me-sender:x-sasl-enc; s=fm3; bh=13EzZWme3ZcL3ch+K
 5q+GuXZepVH5OdxynoOLIR1/xE=; b=nXktfSv/LJZhaPCuBNz1JbEiTuhA6rfyO
 Y8k4y/ULQUJwd7l5XGOEc1d0kVXv9xYwPHSiZvmlZSkhTYpQ6ES1EnWqsRNDWi7G
 Wl2UTLZjBovkkCFxrrK9hsa7v/1Zn096D0sKvo9dUfwEVd4SMHmZ+XZBAAeTTZAT
 iSlUjZ9t1dX7xBr+uDBtMV1zlJ8ELllOmwRXm2NwUbCe02v4LCI8Q1MQsA4ESV1D
 +k4jYJAeCa5xyMJjHWZBSk1GajY+ZNKJTuyiYKT7lLdcR/G3WnhVV/YObAjhZkrj
 mSIW+gYG3Rc/VsDuu5z66w+qvgIf+Klc/3mkmiYTY5T0jNSJ/EOAA==
X-ME-Sender: <xms:V1znXl4m1TieKLaI8hct0LUZs3FU212a3_z3j6Rq2sL0OFDB_9g_mg>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudeikedggeduucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfffkgggtsehttdertddttddtnecuhfhrohhmpedfrfhhihhlihhp
 ucfmrddfuceophhhihhlihhpseifrghrphhmrghilhdrnhgvtheqnecuggftrfgrthhtvg
 hrnhepheeuieffveevkeetffeufeekfeejkeekkeefjeelueeftdduffdugfeuieegfffh
 necukfhppeejledrvdduledrudelledrvdduheenucevlhhushhtvghrufhiiigvpedtne
 curfgrrhgrmhepmhgrihhlfhhrohhmpehphhhilhhiphesfigrrhhpmhgrihhlrdhnvght
X-ME-Proxy: <xmx:V1znXi7m193gmpx6ZXYG-9VQEYPN6TFNDGYpVZozka9-Ild5mHgRzQ>
 <xmx:V1znXsetgnvb28NW2BEYtgxnDgrAchQnJg2HXGa5kbj99bfOmPMJ6w>
 <xmx:V1znXuIzHAnccMbEI64Z-3Au4fCRIpZfCBdlB6X4CUjq-W8oEoa5_g>
 <xmx:V1znXuW-NDCiG5m0TReX4EUnOIQw9ZFb2tC-jCDemfHAF5THF_asSw>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id 52FB7328005E;
 Mon, 15 Jun 2020 07:32:39 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
In-Reply-To: <87sgewr3n0.fsf@HIDDEN> (contovob@HIDDEN)
Date: Mon, 15 Jun 2020 13:32:36 +0200
Message-ID: <87wo48r2cr.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


Thanks for the notes, just a few questions/justifications below:

"Basil L. Contovounesios" <contovob@HIDDEN> writes:

>> And it might be worth considering to add a prompt, to ask the user if
>> they actually want to kill all the buffers.
>
> Something like "Kill <N> buffers under <root>? "?

Yes, I'll propose something like that in my next patch.

>> +        (when (file-in-directory-p true root)
>> +          (push buf bufs))))
>> +    bufs))
>
> Maybe the list should be returned in the same order as (buffer-list), by
> using either nreverse or seq-filter?

Is there any benifit to this, or is this just a matter of not disrupting
expectations? My thought was that this was more like a set than a proper
list (despite the function name).

>> +    (dolist (buf (project--list-buffers pr))
>> +      (let ((match (mapcar (lambda (re)
>> +                             (and (string-match-p re (buffer-name buf)) t))
>> +                           project-dont-clean-regexps)))
>> +        (unless (memq t match)
>> +          (kill-buffer buf))))))
>
> Nit: AKA
>
>   (unless (seq-some (lambda (re)
>                       (string-match-p re (buffer-name buf)))
>                     project-dont-clean-regexps)
>     ...)

Would this require adding a "(require 'seq)" to the top? I always kind
of hesistate in adding new dependencies in patches, but if it's already
loaded, it would look better this way.

-- 
	Philip K.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at 41868 <at> debbugs.gnu.org:


Received: (at 41868) by debbugs.gnu.org; 15 Jun 2020 11:05:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 07:05:02 2020
Received: from localhost ([127.0.0.1]:45339 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jkmvG-0004nQ-0z
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:05:02 -0400
Received: from mail-wm1-f47.google.com ([209.85.128.47]:53043)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1jkmvD-0004n2-Db
 for 41868 <at> debbugs.gnu.org; Mon, 15 Jun 2020 07:05:00 -0400
Received: by mail-wm1-f47.google.com with SMTP id r9so14195913wmh.2
 for <41868 <at> debbugs.gnu.org>; Mon, 15 Jun 2020 04:04:59 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=cVaDLxyxPPCYzCSp/SIOSpl9FZJ+3W08yCt1Av+6V9M=;
 b=YMRoOfPdZ9zKgZWMAhIBiwmfyWZBxRVfwpNkXVHtNd8n6GiS8Kx82GUk8YHDKQ7JTP
 bP5pEhbvd04ToiwfCeNyPrsiY4LUht96cKT1U6ufyxCsmBr2ntnuzT8MOJzPfXf0ly9n
 AEEFoI5OwdgGdb1heJq4/mTPZEZaSk6mPJ0Vwje9jcPkKc1fz2UZkgHYKCQGE9wJ0LNW
 akfZh/94mS58KP1GcvzlDGlbaWG/xUdkNEDKsqIne99DhD/nXNbh2Sn4ipsvQd2NuTN2
 XN1k6zkfTwaP9W8jqSB4BIUXo4qG7Hl63vaa/TTVo9qhidLTkyKdEEEUNrwmQzokm0AI
 8QkA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=cVaDLxyxPPCYzCSp/SIOSpl9FZJ+3W08yCt1Av+6V9M=;
 b=JgKQM5JgOl44kzHobGwx07KVeQRPUahKvioUiJo1+lQTxCmjTEJTUVKY7fYtnl5o26
 zOSj78074KcmkfVfqi0OGGoqS3Zk7jPQr3oNvxYjmoBqgqPqvCHRi8HBE8nFX5ozkuvK
 vaw0tpirSn8sUfFe7FJUqBkBPg6FjGc2hugg8PPYiFJWcq2yTCH/yUHIUw+3T3Y6GtlZ
 x+VJFBV1ozlYBdFdFtbNodO28mMHyaA/0sDsITxJ4hPLj/2iwPL/gjp1WFeySkOo+4+o
 uPitymlDGCze7PCvxSWgh5ZShlBoAlxWp0vUm36muh5KpNE761EcfypEQ/nFaMLvaNru
 0Gyw==
X-Gm-Message-State: AOAM531+wne0bUCdChaNIj6nI0oKFuuaedkdgxjm6kqDvutFjf/UdR+4
 5UV37CsfGMq0MmRY5+jVzl9D3Q==
X-Google-Smtp-Source: ABdhPJz3vKWWoZ5NdVow1cX4Y6szm7euzFZExnnGntxT9po2Z05KGmy7KKHTXXN9Nj4Xzfngfsd79A==
X-Received: by 2002:a7b:c3c6:: with SMTP id t6mr12036322wmj.159.1592219093489; 
 Mon, 15 Jun 2020 04:04:53 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:1f68:7ff5:120d:64e])
 by smtp.gmail.com with ESMTPSA id a1sm21641558wmj.29.2020.06.15.04.04.52
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 15 Jun 2020 04:04:52 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: "Philip K." <philip@HIDDEN>
Subject: Re: bug#41868: [PATCH] Add project-clean-up command
References: <87k108wsvb.fsf@HIDDEN>
Date: Mon, 15 Jun 2020 12:04:51 +0100
In-Reply-To: <87k108wsvb.fsf@HIDDEN> (Philip K.'s message of "Mon, 15
 Jun 2020 12:00:56 +0200")
Message-ID: <87sgewr3n0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 41868
Cc: 41868 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

"Philip K." <philip@HIDDEN> writes:

> I wanted to propose a command for project.el to kill all opened buffers
> in a project, called when one finishes working on some specific
> code-base.

Thanks, just some minor nits from me.

[...]

> And it might be worth considering to add a prompt, to ask the user if
> they actually want to kill all the buffers.

Something like "Kill <N> buffers under <root>? "?

[...]

> +(defcustom project-dont-clean-regexps
> +  '("\\*Help\\*")
> +  "List of regular expressions to be ignored by `project-clean-up'."
> +  :type '(repeat regexp))

This needs a :version tag.

> +(defun project--list-buffers (pr)
> +  "Return a list of all buffers in project PR."
> +  (let ((root (project-root pr))
> +        bufs)
> +    (dolist (buf (buffer-list))
> +      (when-let* ((path (or (buffer-file-name buf)
                      ^^^^
Nit: Paths in Emacs are directory lists, whereas this is a file name.

> +                            (buffer-local-value 'default-directory buf)))
> +                  (true (file-truename path)))

Doesn't file-in-directory-p do this for us?

> +        (when (file-in-directory-p true root)
> +          (push buf bufs))))
> +    bufs))

Maybe the list should be returned in the same order as (buffer-list), by
using either nreverse or seq-filter?

> +;;;###autoload
> +(defun project-clean-up ()
> +  "Kill all opened buffers in a project."
               ^^^^^^
               live?

> +  (interactive)
> +  (let* ((pr (project-current t)))

Nit: No need for let*.

> +    (dolist (buf (project--list-buffers pr))
> +      (let ((match (mapcar (lambda (re)
> +                             (and (string-match-p re (buffer-name buf)) t))
> +                           project-dont-clean-regexps)))
> +        (unless (memq t match)
> +          (kill-buffer buf))))))

Nit: AKA

  (unless (seq-some (lambda (re)
                      (string-match-p re (buffer-name buf)))
                    project-dont-clean-regexps)
    ...)

Thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 15 Jun 2020 10:01:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 15 06:01:10 2020
Received: from localhost ([127.0.0.1]:45278 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jklvS-00037w-FV
	for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 06:01:10 -0400
Received: from lists.gnu.org ([209.51.188.17]:44980)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <philip@HIDDEN>) id 1jklvQ-00037o-5G
 for submit <at> debbugs.gnu.org; Mon, 15 Jun 2020 06:01:08 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:43860)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <philip@HIDDEN>)
 id 1jklvP-0007ee-Pj
 for bug-gnu-emacs@HIDDEN; Mon, 15 Jun 2020 06:01:07 -0400
Received: from wout5-smtp.messagingengine.com ([64.147.123.21]:55779)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <philip@HIDDEN>)
 id 1jklvL-00016A-1k
 for bug-gnu-emacs@HIDDEN; Mon, 15 Jun 2020 06:01:07 -0400
Received: from compute2.internal (compute2.nyi.internal [10.202.2.42])
 by mailout.west.internal (Postfix) with ESMTP id 3032C5E8
 for <bug-gnu-emacs@HIDDEN>; Mon, 15 Jun 2020 06:01:00 -0400 (EDT)
Received: from mailfrontend2 ([10.202.2.163])
 by compute2.internal (MEProxy); Mon, 15 Jun 2020 06:01:00 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=warpmail.net; h=
 from:to:subject:date:message-id:mime-version:content-type; s=
 fm3; bh=QeGDQSfC+YjauFrerW2QlNmxH68VhjTCuu7LLgbF8J0=; b=KSOTCsNU
 i5hQcJ6V0k5IPXkOOP8cg43NY0N6nlAkCMD9XQC7+Ms08/O1swawbIJ+1l/I7asM
 W5XtvELcQ6bbs7t6QrxDqOiY3wVWn7JZutsuQA6MhVOn+54uh7kqFq2VbG27YNtA
 5btxBuqYC+/Xq4alnLSgLUGaC3bNv4vi5HjDVhF0qTfZOrjGgJ0dDe5IbH4L6V3c
 VsrAsy6Ma1tloDgzHZ+XtzaAD+EzcaQ6kUbF5dUONN/s+4tJ0AKkTAQz/qNPrYUS
 plvHI5CHIKGyncyqn/g06ojh/3Uf8w2D6gvkIWkio1lPWnnm20LoxJ5UTm6F9CS7
 /6ZmCqH56kcXpw==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=content-type:date:from:message-id
 :mime-version:subject:to:x-me-proxy:x-me-proxy:x-me-sender
 :x-me-sender:x-sasl-enc; s=fm3; bh=QeGDQSfC+YjauFrerW2QlNmxH68Vh
 jTCuu7LLgbF8J0=; b=P015X+ieYSS4MIulK4fNy0Pc65VwuQni9+d5TPDUynzCb
 uxZR4dZZWrzefWwlbYsojmDzXYCinPQHakC0ARIRPL1fiVsRnOAF4tvt2iYMpJhM
 RtHgOB5PuJuSftFwoq+to9KhO7W3XaPkcmVo5vUJwLep89o5eHHQB31G/HIBIHLA
 ijh6SAS3xHagq93IDxNsdG73CFkjgvoNePeJUyGFS6BKDnUUDuZ+vaGEyMGYWprn
 AtODPmUUug1bEjeDA7xWsrAnJwKxp9fxxI8mEG+Afs9e/e77gcSwmJpypLrVaCmH
 qd1CbOr+x0Fp9QVBW/VbTGVCHcQtb9aRl7Th80LWg==
X-ME-Sender: <xms:20bnXmTCd2LWCWlz90KVGcOqGL0ieb-Nwz6BmaIPJ4PJS7cOOp6osQ>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduhedrudeikedgvddvucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucenucfjughrpefhvffufffkgggtsehmtderredttd
 dtnecuhfhrohhmpedfrfhhihhlihhpucfmrddfuceophhhihhlihhpseifrghrphhmrghi
 lhdrnhgvtheqnecuggftrfgrthhtvghrnhepgfdtudfhtdelteejieehtdekjefgjefgff
 dtteekfedtvdetgffhjedvledtjeefnecukfhppeejledrvdduledrudelledrvdduheen
 ucevlhhushhtvghrufhiiigvpedtnecurfgrrhgrmhepmhgrihhlfhhrohhmpehphhhilh
 hiphesfigrrhhpmhgrihhlrdhnvght
X-ME-Proxy: <xmx:20bnXry4ybn-EGsx-Mgbd0UasvpnsKHvyYsIwGs67MIc9pWq6-JS-A>
 <xmx:20bnXj3ojKO9JtsRST4Xp5cvBfmJYuYtdWPNfIoirzmCrssd0icfVw>
 <xmx:20bnXiAcxX7F6E-Z729CblGTpiKRrVLxLtIJymVj_LLLDHFLraE80g>
 <xmx:20bnXuRoM1EsgVdUbM_tdCqYJVfgINzSIomTrL4RWGOvbvtCB1RVvA>
Received: from localhost (p4fdbc7d7.dip0.t-ipconnect.de [79.219.199.215])
 by mail.messagingengine.com (Postfix) with ESMTPA id 5CF7F3061856
 for <bug-gnu-emacs@HIDDEN>; Mon, 15 Jun 2020 06:00:59 -0400 (EDT)
From: "Philip K." <philip@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: [PATCH] Add project-clean-up command
Date: Mon, 15 Jun 2020 12:00:56 +0200
Message-ID: <87k108wsvb.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
Received-SPF: pass client-ip=64.147.123.21; envelope-from=philip@HIDDEN;
 helo=wout5-smtp.messagingengine.com
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/06/15 06:01:00
X-ACL-Warn: Detected OS   = Linux 2.2.x-3.x [generic] [fuzzy]
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H3=-0.01, RCVD_IN_MSPIKE_WL=-0.01,
 SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 URIBL_BLOCKED=0.001 autolearn=_AUTOLEARN
X-Spam_action: no action
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.7 (--)

--=-=-=
Content-Type: text/plain


Hi,

I wanted to propose a command for project.el to kill all opened buffers
in a project, called when one finishes working on some specific
code-base. I gave it the name "project-clean-up", but maybe it should be
renamed? I have been using it in my local emacs branch for about a week,
and have found it to be useful.

One issue I ran into is that a buffer might be falsely associated with a
project, such as *Help*. That's why I added an user option
project-dont-clean-regexps to contain a list of regular expression of
what buffer names to spare. The reason I couldn't just stick to checking
the value of buffer-file-name is that Dired, VC, etc. buffers don't get
recognized. There might be a better way to do this, but I'm not sure if
it's worth the effort.

And it might be worth considering to add a prompt, to ask the user if
they actually want to kill all the buffers.

-- 
	Philip K.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Add-project-clean-up-command.patch

From d7d4127cc561b3f2d1650d19a3fb58895a4cabd1 Mon Sep 17 00:00:00 2001
From: Philip K <philip@HIDDEN>
Date: Fri, 12 Jun 2020 23:37:51 +0200
Subject: [PATCH] Add project-clean-up command

---
 lisp/progmodes/project.el | 29 +++++++++++++++++++++++++++++
 1 file changed, 29 insertions(+)

diff --git a/lisp/progmodes/project.el b/lisp/progmodes/project.el
index f3df44fa7b..9e55f3594c 100644
--- a/lisp/progmodes/project.el
+++ b/lisp/progmodes/project.el
@@ -744,6 +744,35 @@ project-compile
          (default-directory (project-root pr)))
     (compile command comint)))
 
+(defcustom project-dont-clean-regexps
+  '("\\*Help\\*")
+  "List of regular expressions to be ignored by `project-clean-up'."
+  :type '(repeat regexp))
+
+(defun project--list-buffers (pr)
+  "Return a list of all buffers in project PR."
+  (let ((root (project-root pr))
+        bufs)
+    (dolist (buf (buffer-list))
+      (when-let* ((path (or (buffer-file-name buf)
+                            (buffer-local-value 'default-directory buf)))
+                  (true (file-truename path)))
+        (when (file-in-directory-p true root)
+          (push buf bufs))))
+    bufs))
+
+;;;###autoload
+(defun project-clean-up ()
+  "Kill all opened buffers in a project."
+  (interactive)
+  (let* ((pr (project-current t)))
+    (dolist (buf (project--list-buffers pr))
+      (let ((match (mapcar (lambda (re)
+                             (and (string-match-p re (buffer-name buf)) t))
+                           project-dont-clean-regexps)))
+        (unless (memq t match)
+          (kill-buffer buf))))))
+
 
 ;;; Project list
 
-- 
2.20.1


--=-=-=--




Acknowledgement sent to "Philip K." <philip@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#41868; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 18 Jun 2020 15:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.